// ============================================================
// Project				:	CityRPG
// Author				:	Iban
// Description			:	Code that operates the Admin GUI.
// ============================================================

// ============================================================
// Section 1 : Object Initiation
// ============================================================
while(isObject(CRPG_Admin))
{
	CRPG_Admin.delete();
}

while(isObject(CRPG_AdminButton))
{
	CRPG_AdminButton.delete();
}

exec($CRPG_C::Path @ "guis/admin.gui");

new GuiBitmapButtonCtrl(CRPG_AdminButton)
{
	profile = "CRPGButtonProfile";
	horizSizing = "left";
	vertSizing = "bottom";
	position = "205 254";
	extent = "99 19";
	minExtent = "8 2";
	visible = "0";
	command = "canvas.pushDialog(CRPG_Admin);";
	text = "CityRPG";
	groupNum = "-1";
	buttonType = "PushButton";
	bitmap = "Add-Ons/Client_CityRPG/images/ui/button1";
	lockAspectRatio = "0";
	alignLeft = "0";
	overflowImage = "0";
	mKeepCached = "0";
	mColor = "0 200 200 255";
};

AdminGUI.getObject(0).add(CRPG_AdminButton);

// ============================================================
// Section 2 : Functions
// ============================================================
function CityRPG_openAdmin(%button)
{
	if($CRPG_C::Active)
	{
		if(%button)
		{
			if($IAmAdmin > 0)
			{
				%gui = CRPG_Admin;
			}
			else
			{
				%gui = AdminLoginGUI;
			}
			
			canvas.pushDialog(%gui);
		}
	}
}

function CRPG_Admin::onWake(%gui)
{
	commandToServer('Admin_GetProfileList');
	CRPG_Admin_Window.text = "CityRPG Administration";
}

function CRPG_Admin::sortList(%gui, %col)
{
	CRPG_Admin_List.sort(%col, CRPG_Admin_List.sort);
	CRPG_Admin_List.sort = !CRPG_Admin_List.sort;
	return CRPG_Admin_List.sort;
}

function CRPG_Admin::sortNumList(%gui, %col)
{
	CRPG_Admin_List.sortNumerical(%col, CRPG_Admin_List.numSort);
	CRPG_Admin_List.numSort = !CRPG_Admin_List.numSort;
	return CRPG_Admin_List.numSort;
}

function CRPG_Admin::adminCommand(%gui, %command, %warn)
{
	if($IAmAdmin == 2)
	{
		%row = CRPG_Admin_List.getSelectedID();
		
		if(%row >= 0)
		{
			%name = getField(CRPG_Admin_List.getRowTextById(%row), 0);
			%id = getField(CRPG_Admin_List.getRowTextById(%row), 5);
			
			if(%warn !$= "")
			{
				MessageBoxOkCancel("Are you sure?", "You are about to" SPC %warn SPC %name @ "." NL "This cannot be undone.", "commandToServer('Admin_" @ %command @ "', \"" @ %id @ "\");", "");
			}
			else
			{
				MessageBoxOK("Just a Moment", "Communicating with the Server.\n\nHold tight.");
				eval("%command = 'Admin_" @ %command @ "';");
				commandToServer(%command, %id, CityRPG_Admin_Input.getValue());
			}
		}
		else
		{
			MessageBoxOK("Does Not Compute", "Please select a row first.");
		}
	}
	else
	{
		MessageBoxOK("Does Not Compute", "You are not an admin, so you cannot use admin commands.");
	}
}

// ============================================================
// Section 3 : ClientCmds
// ============================================================
function clientCmdAdmin_AddProfile(%name, %money, %demerits, %job, %id)
{
	CRPG_Admin_List.addRow(CRPG_Admin_List.rowCount(), %name TAB "$" TAB %money TAB %demerits TAB %job TAB %id);
}

function clientCmdAdmin_ClearProfileSO()
{
	CRPG_Admin_List.clear();
}