// Source: System_ReturnToBlockland/RTBC_ModManager.cs

if($RTB::Support::GUI)
	return;

//*********************************************************
//* Mouse Event Handling
//* -------------------------------------------------------
//* This setup allows mouseEventCtrls to contain other
//* controls within itself that you can mouseover without
//* the engine thinking you left the mouse event ctrl.
//* Its just a looping check to see if you're within the
//* bounds - and performance it'll reduce the number of
//* checks if you've left the mouse afk in the ctrl or
//* something. Shouldn't cause trouble really.
//*********************************************************
//- GuiMouseEventCtrl::onMouseEnter (Hack)
function GuiMouseEventCtrl::onMouseEnter(%this)
{   
   if(%this.eventType !$= "")
   {
      if(strLen(%this.eventCallbacks) == 4)
      {
         if(getSubStr(%this.eventCallbacks,0,1) $= 1)
         {
            %command = "Event_" @ %this.eventType @ "::onMouseEnter(" @ %this @ ");";
            eval(%command);
            %isSpecial = 1;
         }
      }
   }
   
   if(!%isSpecial)
   {
      if(isFunction(Parent,"onMouseEnter"))
      {
         Parent::onMouseEnter(Parent);
      }
   }
}

//- GuiMouseEventCtrl::onMouseLeave (Epic Hack, So bad it makes me sick)
function GuiMouseEventCtrl::onMouseLeave(%this)
{
   if(%this.persistent)
   {
      %position = %this.getCanvasPosition();
      %minX = getWord(%position,0);
      %maxX = getWord(%position,0) + getWord(%this.extent,0);
      %minY = getWord(%position,1);
      %maxY = getWord(%position,1) + getWord(%this.extent,1);
      %curX = getWord(Canvas.getCursorPos(),0);   
      %curY = getWord(Canvas.getCursorPos(),1);

      if(%curX > %minX && %curX < %maxX && %curY > %minY && %curY < %maxY)
      {
         if(%this.checks > 1000)
            %sch = 1000;
         else if(%this.checks > 500)
            %sch = 100;
         else
            %sch = 10;

         %this.schedule(%sch,"onMouseLeave");
         %this.checks++;
         return;
      }
   }
   
   if(%this.eventType !$= "")
   {
      if(strLen(%this.eventCallbacks) == 4)
      {
         if(getSubStr(%this.eventCallbacks,1,1) $= 1)
         {
            %command = "Event_"@%this.eventType@"::onMouseLeave("@%this@");";
            eval(%command);
            %isSpecial = 1;
            %this.checks = 0;
         }
      }
   }
   
   if(!%isSpecial)
   {
      if(isFunction(Parent,"onMouseLeave"))
      {
         Parent::onMouseLeave(Parent);
      }
   }
}

//- GuiMouseEventCtrl::onMouseDown (Hack)
function GuiMouseEventCtrl::onMouseDown(%this)
{
   if(%this.eventType !$= "")
   {
      if(strLen(%this.eventCallbacks) == 4)
      {
         if(getSubStr(%this.eventCallbacks,2,1) $= 1)
         {
            %command = "Event_"@%this.eventType@"::onMouseDown("@%this@");";
            eval(%command);
            %isSpecial = 1;
         }
      }
   }
   
   if(!%isSpecial)
   {
      if(isFunction(Parent,"onMouseDown"))
      {
         Parent::onMouseDown(Parent);
      }
   }
}

//- GuiMouseEventCtrl::onMouseUp (Hack)
function GuiMouseEventCtrl::onMouseUp(%this)
{
   if(%this.eventType !$= "")
   {
      if(strLen(%this.eventCallbacks) == 4)
      {
         if(getSubStr(%this.eventCallbacks,3,1) $= 1)
         {
            %command = "Event_"@%this.eventType@"::onMouseUp("@%this@");";
            eval(%command);
            %isSpecial = 1;
         }
      }
   }
   
   if(!%isSpecial)
   {
      if(isFunction(Parent,"onMouseUp"))
      {
         Parent::onMouseUp(Parent);
      }
   }
}
