// ============================================================
// Project				:	CityRPG
// Author				:	Iban
// Description			:	Code that operates the Bank GUI.
// ============================================================

// ============================================================
// Section 1 : Object Initiation
// ============================================================
while(isObject(CRPG_Noob))
{
	CRPG_Noob.delete();
}

exec($CRPG_C::Path @ "guis/noob.gui");

// ============================================================
// Section 2 : Functions
// ============================================================
function clientCmdNoob_Display()
{
	$CRPG_C::NoobDisplay = true;
	canvas.pushDialog(CRPG_Noob);
}

function clientCmdNoob_Hide()
{
	$CRPG_C::NoobDisplay = "";
	canvas.popDialog(CRPG_Noob);
}

function CRPG_Noob::pickJob(%gui, %job)
{
	commandToServer('Noob_PickJob', %job);
}

function CRPG_Noob::setPanel(%gui, %job)
{
	CRPG_Noob_Confirm_Btn.command = "CRPG_Noob.pickJob(" @ mFloor(%job) @ ");";
	CRPG_Noob_Confirm_Btn.setVisible(%job > 0 ? true : false);
	
	for(%a = 0; %a < CRPG_Noob_Frames.getCount(); %a++)
	{
		%frame	= CRPG_Noob_Frames.getObject(%a);
		%button	= ("CRPG_Noob_" @ %frame.jobField @ "_Button");
		%visible	= (%frame.jobField $= %job) ? true : false;
		
		%frame.setVisible(%visible);
		
		if(isObject(%button))
			%button.setActive(!%visible);
	}
}