// ============================================================
// Project				:	CityRPG
// Author				:	Iban
// Description			:	Code that operates the Police GUI.
// ============================================================

// ============================================================
// Section 1 : Object Initiation
// ============================================================
while(isObject(CRPG_Police))
{
	CRPG_Police.delete();
}

exec($CRPG_C::Path @ "guis/police.gui");

// ============================================================
// Section 2 : Functions
// ============================================================
function CRPG_Police::onWake(%gui)
{
	commandToServer('Police_GetWantedList');
	commandToServer('Police_GetRecoveryList');
	%gui.setPane(0);
}

function CRPG_Police::setPane(%gui, %id)
{
	%id = mClamp(%id, 0, %id);
	
	if(%id < %gui.numPanes)
	{
		for(%a = 0; %a < %gui.numPanes; %a++)
		{
			if(%id == %a)
			{
				%gui.tab[%a].setBitmap("Add-Ons/Client_CityRPG/images/ui/Tab1use");
				%gui.pane[%a].setVisible(true);
			}
			else
			{
				%gui.tab[%a].setBitmap("Add-Ons/Client_CityRPG/images/ui/Tab1");
				%gui.pane[%a].setVisible(false);
			}
		}
	}
}

function CRPG_Police::sortList(%gui, %list, %col)
{
	%list.sort(%col, %list.sort);
	%list.sort = !%list.sort;
	return %list.sort;
}

function CRPG_Police::sortNumList(%gui, %list, %col)
{
	%list.sortNumerical(%col, %list.numSort);
	%list.numSort = !%list.numSort;
	return %list.numSort;
}

function CRPG_Police::summonInvestigation(%gui)
{
	%row = CRPG_Police_VList.getSelectedID();
	
	if(%row >= 0)
	{
		%text = CRPG_Police_VList.getRowTextByID(%row);
		%id = getField(%text, 3);
		
		commandToServer('Police_FindVehicle', %id);
	}
}

// ============================================================
// Section 3 : ClientCmds
// ============================================================
function clientCmdPolice_AddWanted(%name, %demerits)
{
	CRPG_Police_List.addRow(CRPG_Police_List.rowCount(), %name TAB %demerits);
}

function clientCmdPolice_ClearWanted()
{
	CRPG_Police_List.clear();
}

function clientCmdPolice_SetStats(%comitted, %unsolved, %solved, %clues)
{
	%comitted	= CRPG_Condense(%comitted);
	%unsolved	= CRPG_Condense(%unsolved);
	%solved		= CRPG_Condense(%solved);
	%clues		= CRPG_Condense(%clues);
	
	CRPG_Police_Crimes.setText("<just:center>" @ %comitted SPC "Crimes Committed");
	CRPG_Police_Unsolved.setText("<just:center>" @ %unsolved SPC "Total Unsolved");
	CRPG_Police_Solved.setText("<just:center>" @ %solved SPC "Total Solved");
	CRPG_Police_Clues.setText("<just:center>" @ %clues SPC "Hidden Clues");
}

function clientCmdPolice_SetRecovery(%names, %prices, %ids)
{
	CRPG_Police_VList.clear();
	
	for(%i = 0; %i < getFieldCount(%names); %i++)
	{
		%name	= getField(%names, %i);
		%cost	= getField(%prices, %i);
		%cost	= mFloor(%cost);
		%id	= getField(%ids, %i);
		
		if(%name !$= "")
			CRPG_Police_VList.addRow(CRPG_Police_VList.rowCount(), %name TAB "$" TAB %cost TAB %id);
	}
}