// ============================================================
// Project				:	CityRPG
// Author				:	Iban
// Description			:	Code that operates the Status GUI.
// ============================================================

// ============================================================
// Section 1 : Object Initiation
// ============================================================
while(isObject(CityRPG_Status))
	CityRPG_Status.delete();

exec($CRPG_C::Path @ "guis/status.gui");

if(isObject(CityRPG_Status))
{
	PlayGUI.add(CityRPG_Status);
	CityRPG_Status.schedule(32, "fixPosition");
	CityRPG_Status.setVisible($CRPG_C::Active);
}

while(isObject(HUD_AmmoNameBG))
	HUD_AmmoNameBG.delete();

if(!isObject(HUD_AmmoNameBG))
{
	new GuiBitmapCtrl(HUD_AmmoNameBG) {
		profile = "HUDBrickNameProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "960 338";
		extent = "64 36";
		minExtent = "8 2";
		visible = "0";
		bitmap = $CRPG_C::Path @ "images/ui/AmmoLabelBG";
		wrap = "0";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		keepCached = "0";

		new GuiTextCtrl(HUD_AmmoName) {
			profile = "HUDCenterTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 0";
			extent = "64 18";
			minExtent = "8 2";
			visible = "1";
			text = "";
			maxLength = "255";
		};
		new GuiTextCtrl(HUD_AmmoQuan) {
			profile = "HUDCenterTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "0 18";
			extent = "64 18";
			minExtent = "8 2";
			visible = "1";
			text = "";
			maxLength = "255";
		};
	};
	
	PlayGUI.add(HUD_AmmoNameBG);
}

$CRPG_C::Module::Status::Font = "<just:center><color:ffffff>";

// ============================================================
// Section 2 : Functions
// ============================================================
function adjustCityRPGStatus()
{
	CityRPG_Status.fixPosition();
	
	CityRPG_Status_NoData.setVisible(false);
	CityRPG_Status_Data.setVisible(true);
	
	// Cash
	CityRPG_Status_Text_1.setText($CRPG_C::Module::Status::Font @ "<color:00ff00>$" @ CRPG_Datum.var["MONEY"]);
	CityRPG_Status_Icon_1.setBitmap($CRPG_C::Path @ "images/icons/Icon_Money");
	
	// Hunger
	%hunger = CRPG_Datum.var["HUNGER"];
	
	if(%hunger >= 100)
		%hunger = "<color:00ff00>" @ %hunger;
	else if(%hunger <= 0)
		%hunger = "<color:ff0000>" @ %hunger;
	else
	{
		%green = 256 * (%hunger / 100);
		%red = 256 - %green;
		%blue = "00";
		
		// Green
		%tens = mFloor(%green / 16);
		
		if(%tens > 9)
			switch(%tens)
			{
				case 10: %tens = "a";
				case 11: %tens = "b";
				case 12: %tens = "c";
				case 13: %tens = "d";
				case 14: %tens = "e";
				case 15: %tens = "f";
			}
		
		%ones = %green % 16;
		
		if(%ones > 9)
			switch(%ones)
			{
				case 10: %ones = "a";
				case 11: %ones = "b";
				case 12: %ones = "c";
				case 13: %ones = "d";
				case 14: %ones = "e";
				case 15: %ones = "f";
			}
		
		%green = %tens @ %ones;
		
		// Red
		%tens = mFloor(%red / 16);
		
		if(%tens > 9)
			switch(%tens)
			{
				case 10: %tens = "a";
				case 11: %tens = "b";
				case 12: %tens = "c";
				case 13: %tens = "d";
				case 14: %tens = "e";
				case 15: %tens = "f";
			}
		
		%ones = %red % 16;
		
		if(%ones > 9)
			switch(%ones)
			{
				case 10: %ones = "a";
				case 11: %ones = "b";
				case 12: %ones = "c";
				case 13: %ones = "d";
				case 14: %ones = "e";
				case 15: %ones = "f";
			}
		
		%red = %tens @ %ones;
		
		%hunger = "<color:" @ %red @ %green @ %blue @ ">" @ %hunger;
	}
	
	CityRPG_Status_Text_2.setText($CRPG_C::Module::Status::Font @ %hunger @ "% Full");
	CityRPG_Status_Icon_2.setBitmap($CRPG_C::Path @ "images/icons/Icon_Hunger");
	
	// Resources
	if(CRPG_Datum.var["PLASTIC"])
	{
		if(CRPG_Datum.var["PLASTIC"] > 1)
		{
			%plural = "s";
		}
		
		CityRPG_Status_Text_3.setText($CRPG_C::Module::Status::Font @ CRPG_Datum.var["PLASTIC"] @ " Chunk" @ %plural);
	}
	else
	{
		CityRPG_Status_Text_3.setText($CRPG_C::Module::Status::Font @ "No Plastic");
	}
	CityRPG_Status_Icon_3.setBitmap($CRPG_C::Path @ "images/icons/Icon_Plastic");
	
	// Lot Owner
	if(CRPG_Datum.var["JOB"] $= "Convict")
	{
		CityRPG_Status_Text_4.setText($CRPG_C::Module::Status::Font @ CRPG_Datum.var["JOB"]);
		CityRPG_Status_Icon_4.setBitmap($CRPG_C::Path @ "images/icons/Icon_Crime_Inmate");
	}
	else
	{
		if(CRPG_Datum.var["LOTOWNER"] !$= "")
		{
			CityRPG_Status_Text_4.setText($CRPG_C::Module::Status::Font @ CRPG_Datum.var["LOTOWNER"]);
			CityRPG_Status_Icon_4.setBitmap($CRPG_C::Path @ "images/icons/Icon_Lot");
		}
		// Job
		else
		{
			CityRPG_Status_Text_4.setText($CRPG_C::Module::Status::Font @ CRPG_Datum.var["JOBNAME"]);
			CityRPG_Status_Icon_4.setBitmap($CRPG_C::Path @ "images/icons/Icon_Job");
		}
	}
	
	// Wanted Level
	if(CRPG_Datum.var["SENTENCE"] != 0)
	{
		CityRPG_Status_Icon_5.setVisible(true);
		CityRPG_Status_Text_5.setVisible(true);
		
		for(%a = 1; %a <= 12; %a++)
		{
			%icon = "CityRPG_Status_Star_" @ %a;
			%icon.setVisible(false);
		}
		
		if(CRPG_Datum.var["SENTENCE"] > 0)
		{
			if(CRPG_Datum.var["SENTENCE"] > 1)
				%plural = "s";
			
			CityRPG_Status_Text_5.setText($CRPG_C::Module::Status::Font @ "<color:fde689>" @ CRPG_Datum.var["SENTENCE"] @ " Tick" @ %plural @ " Left");
		}
		else
		{
			CityRPG_Status_Text_5.setText($CRPG_C::Module::Status::Font @ "<color:fde689>Life in Jail");
		}
		
		CityRPG_Status_Icon_5.setBitmap($CRPG_C::Path @ "images/icons/Icon_Crime_Jailed");
	}
	else
	{
		CityRPG_Status_Icon_5.setVisible(false);
		CityRPG_Status_Text_5.setVisible(false);
		
		for(%a = 1; %a <= 12; %a++)
		{
			%icon = "CityRPG_Status_Star_" @ %a;
			%icon.setVisible(%a <= CRPG_Datum.var["WANTEDLEVEL"]);
			
			if(%a <= 6)
				%icon.setBitmap($CRPG_C::Path @ "images/icons/Icon_Crime_Wanted");
			else
				%icon.setBitmap($CRPG_C::Path @ "images/icons/Icon_Crime_Wanted_Red");
		}
	}
	
	// Gender
	switch(CRPG_Datum.var["GENDER"])
	{
		case 0: CityRPG_Status_Icon_6.setBitmap($CRPG_C::Path @ "images/icons/Icon_Gender_Unknown");
		case 1: CityRPG_Status_Icon_6.setBitmap($CRPG_C::Path @ "images/icons/Icon_Gender_Male");
		case 2: CityRPG_Status_Icon_6.setBitmap($CRPG_C::Path @ "images/icons/Icon_Gender_Fem");
	}
	
	// Student
	if(CRPG_Datum.var["STUDENT"] == 0)
	{
		CityRPG_Status_Icon_7.setBitmap($CRPG_C::Path @ "images/icons/Icon_Edu_Lv" @ CRPG_Datum.var["EDUCATION"]);
	}
	else if(CRPG_Datum.var["STUDENT"] == 1)
	{
		CityRPG_Status_Icon_7.setBitmap($CRPG_C::Path @ "images/icons/Icon_Edu_Almost");
	}
	else
	{
		CityRPG_Status_Icon_7.setBitmap($CRPG_C::Path @ "images/icons/Icon_Edu_Student");
	}
	
	// Daylight
	if(CRPG_Datum.var["DAYLIGHT"])
	{
		CityRPG_Status_Icon_8.setBitmap($CRPG_C::Path @ "images/icons/Weather_Sun");
		CityRPG_Status_Icon_8.setVisible(true);
	}
	else
	{
		CityRPG_Status_Icon_8.setVisible(false);
	}
	
	// Debt
	if(CRPG_Datum.var["DEBT"] > 0)
	{
		CityRPG_Status_Icon_9.setBitmap($CRPG_C::Path @ "images/icons/Icon_Debt");
		CityRPG_Status_Icon_9.setVisible(true);
	}
	else
	{
		CityRPG_Status_Icon_9.setVisible(false);
	}
}

function CityRPG_toggleStatus(%button)
{
	if($CRPG_C::Active)
	{
		if(%button)
		{
			if(!CityRPG_Status.moving)
			{
				%xPos = getWord(CityRPG_Status.position, 0);
				%distFromZero = %xPos * -1;
				%xExt = getWord(CityRPG_Status.extent, 0);
				
				// If we're hiding
				if(%xPos >= 0)
				{
					PlayGUI.hideStatusBox(%distFromZero - (%xExt - 22), 10, 1);
					CityRPG_Status.hidden = true;
					CityRPG_Status.unhidden = false;
				}
				// If we're unhiding.
				else
				{
					PlayGUI.hideStatusBox(%distFromZero, 10, 1);
					//setScrollMode(-1);
					CityRPG_Status.hidden = false;
					CityRPG_Status.unhidden = true;
				}
				
				CityRPG_Status.moving = true;
			}
		}
	}
}

function CityRPG_Status::fixPosition(%gui)
{
	%gui.position = getWord(%gui.position, 0) SPC getWord(HUD_PaintBox.position, 1) - (getWord(%gui.getExtent(), 1) + 8);
	return %gui.position;
}

function PlayGUI::isLookingAtMayor(%gui)
{
	%obj = ServerConnection.getControlObject();
	
	if(isObject(%obj))
	{
		// Space Guy's code (iban no good at math)
		%fvec = %obj.getForwardVector();
		%fX = getWord(%fvec, 0);
		%fY = getWord(%fvec, 1);
		
		%evec = %obj.getEyeVector();
		%eX = getWord(%evec, 0);
		%eY = getWord(%evec, 1);
		%eZ = getWord(%evec, 2);
		
		%eXY = mSqrt((%eX * %eX) + (%eY * %eY));
		%aimVec = (%fX * %eXY) SPC (%fY * %eXY) SPC %eZ;
		
		
		%start	= %obj.getEyePoint();
		%range	= 100;
		%end		= vectorAdd(%start, vectorScale(%aimVec, %range));
		%masks	= ($TypeMasks::FxBrickObjectType | $TypeMasks::PlayerObjectType | $TypeMasks::StaticObjectType | $TypeMasks::TerrainObjectType | $TypeMasks::VehicleObjectType);
		%ray		= containerRayCast(%start, %end, %masks, %obj);
		%col		= getWord(%ray, 0);
		
		echo(%obj.getEyeVector());
		if(isObject(%col) && (%col.getType() & $TypeMasks::PlayerObjectType))
		{
			%image = %col.getMountedImage(2);
			
			if(isObject(%image) && %image.shapeFile $= $CRPG_C::Path @ "shapes/Hat_Mayor.dts")
			{
				return true;
			}
		}
	}
	
	return false;
}

function PlayGUI::hideStatusBox(%gui, %xMovement, %steps, %currStep)
{
	cancel(%gui.movementSchedule);
	
	%move = mFloor(%xMovement / %steps);
	
	%xLoc = getWord(CityRPG_Status.position, 0);
	%yLoc = getWord(CityRPG_Status.position, 1);
	%newXLoc = %xLoc + %move;
	
	CityRPG_Status.position = %newXLoc SPC %yLoc;
	
	if(%currStep < %steps)
	{
		CityRPG_Status.moveSchedule = %gui.schedule(250 / %steps, "hideStatusBox", %xMovement, %steps, %currStep + 1);
	}
	else
	{
		CityRPG_Status.moving = false;
	}
}

// Ammo
function clientCmdCRPGAmmo(%visible, %loaded, %ammo, %current, %max, %carrying)
{
	HUD_AmmoNameBG.setVisible(%visible);
	
	if(%visible)
	{
		HUD_AmmoNameBG.setBitmap($CRPG_C::Path @ "images/ui/" @ (!%loaded ? "No" : "") @ "AmmoLabelBG");
		
		// Name
		HUD_AmmoName.setText(%ammo);
		
		// Clip Details
		%text = %current SPC "/" SPC %max;
		
		if(%carrying !$= "")
			%text = %text SPC "/" SPC %carrying;
		
		HUD_AmmoQuan.setText(%text);
	}
}

package CRPG_Client_Ammo
{
	function PlayGUI::hideToolBox(%gui, %xMovement, %steps, %currStep)
	{
		%result = parent::hideToolBox(%gui, %xMovement, %steps, %currStep);
		
		if(isObject(HUD_AmmoNameBG))
			HUD_AmmoNameBG.position = getWords(vectorAdd(HUD_ToolNameBG.position SPC 0, "0 18 0"), 0, 1);
		
		return %result;
	}
	
	function yaw(%amt)
	{
		return parent::yaw(%amt);
	}
	
	function pitch(%amt)
	{
		return parent::pitch(%amt);
	}
};

activatePackage(CRPG_Client_Ammo);